// ===============================================
//  CGI:   
//
// (C)  .., 1997
//
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//         http://www.dials.ccas.ru/frolov
// ===============================================

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define char_width  8
#define char_height 10

static unsigned char char_bits[10][char_height] = 
{
  { // 0
    0x3C, 0x42, 0x42, 0x42, 0x42, 0x42, 
    0x42, 0x42, 0x42, 0x3C 
  },
  { // 1
    0x10, 0x18, 0x14, 0x10,	0x10, 0x10, 
    0x10, 0x10, 0x10, 0x7C 
  },
  { // 2
    0x3E, 0x22, 0x20, 0x20, 0x10, 0x08, 
    0x04, 0x02, 0x22, 0x3F 
  },
  { // 3
    0x3E, 0x22, 0x40, 0x40, 0x3C, 0x40, 
    0x40, 0x40, 0x22, 0x3E 
  },
  { // 4
    0x10, 0x18, 0x14, 0x12, 0x12, 0x3E, 
    0x10, 0x10, 0x10, 0x38 
  },
  { // 5
    0x3E, 0x02, 0x02, 0x02, 0x3E, 0x20, 
    0x20, 0x20, 0x22, 0x2C 
  },
  { // 6
    0x1C, 0x06, 0x02, 0x02, 0x1E, 0x22, 
    0x22, 0x22, 0x22, 0x1C 
  },
  { // 7
    0x3E, 0x22, 0x20, 0x20, 0x10, 0x08, 
    0x08, 0x08, 0x08, 0x08 
  },
  { // 8
    0x1C, 0x22, 0x22, 0x22, 0x1C, 0x22, 
    0x22, 0x22, 0x22, 0x1C 
  },
  { // 9
    0x1C, 0x22, 0x22, 0x22, 0x3C, 0x20, 
    0x20, 0x20, 0x20, 0x1C 
  },
};

void main(int argc, char *argv[])
{
  CHAR   szBuff[4096];
  HANDLE hCounterFile;
  DWORD  dwBytesRead;
  DWORD  dwBytesWritten;
  BOOL   bResult;
  CHAR   szBuf[20];
  INT    nCounter;
  int    nFinalWidth;
  int    nFinalHeight;
  int    nLine;
  unsigned int nChar;
  int    nDigitOffset;

  hCounterFile = CreateFile("COUNTER.DAT", 
    GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING,
    FILE_FLAG_SEQUENTIAL_SCAN, NULL);

  bResult = ReadFile(hCounterFile, szBuf, 7, 
    &dwBytesRead, NULL);

  CloseHandle(hCounterFile);
  
  sscanf(szBuf, "%d", &nCounter);
  nCounter++;
  sprintf(szBuf, "%05.5ld", nCounter);

  hCounterFile = CreateFile("COUNTER.DAT", 
    GENERIC_WRITE, 0, NULL, CREATE_ALWAYS,
    FILE_FLAG_SEQUENTIAL_SCAN, NULL);

  WriteFile(hCounterFile, szBuf, strlen(szBuf),
    &dwBytesWritten, NULL);

  CloseHandle(hCounterFile);
  
  printf(szBuff, "Content-type: image/x-xbitmap\n\n");

  nFinalWidth  = char_width * strlen(szBuf);
  nFinalHeight = char_height;

  printf("Expires: Thu, 03 Dec 1996 10:00:00 GMT\n");
  printf("Pragma: no-cache\n");
  printf("#define counter_width %d\n", nFinalWidth);
  printf("#define counter_height %d\n", nFinalHeight);

  printf("static unsigned char counter_bits[] = {\n");

  for(nLine=0; nLine < nFinalHeight; nLine++)
  {
    for(nChar=0; nChar < strlen(szBuf); nChar++)
	{
      nDigitOffset = szBuf[nChar] - '0';
      printf("0x%02X, ", char_bits[nDigitOffset][nLine]);
	}
  }
  printf("};\n");
}